%global majorversion 0
%global minorversion 3
%global microversion 19

%global apiversion   0.3
%global spaversion   0.2
%global soversion    0
%global libversion   %{soversion}.%(bash -c '((intversion = (%{minorversion} * 100) + %{microversion})); echo ${intversion}').0

%define libname	%mklibname %{name} %{apiversion} %{soversion}
%define devname	%mklibname %{name} -d

%global enable_alsa 1

%if 0%{?mageia}
%global enable_jack 1
%global enable_pulse 1
%global enable_vulkan 1
%endif

Name:		pipewire
Summary:	Media Sharing Server
Version:        %{majorversion}.%{minorversion}.%{microversion}
Release:        %mkrel 1%{?snap:.%{snap}git%{shortcommit}}
Group:		System/Servers
License:        MIT
URL:		https://pipewire.org/
Source0:	https://github.com/PipeWire/pipewire/archive/%{version}/%{name}-%{version}.tar.gz

## upstream patches

## upstreamable patches

## fedora patches

BuildRequires:	meson >= 0.49.0
BuildRequires:	gcc
BuildRequires:  pkgconfig
BuildRequires:	pkgconfig(libudev)
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(glib-2.0) >= 2.32
BuildRequires:	pkgconfig(gio-unix-2.0) >= 2.32
BuildRequires:	pkgconfig(gstreamer-1.0) >= 1.10.0
BuildRequires:	pkgconfig(gstreamer-base-1.0) >= 1.10.0
BuildRequires:	pkgconfig(gstreamer-plugins-base-1.0) >= 1.10.0
BuildRequires:	pkgconfig(gstreamer-net-1.0) >= 1.10.0
BuildRequires:	pkgconfig(gstreamer-allocators-1.0) >= 1.10.0
BuildRequires:	pkgconfig(systemd) >= 184
%if 0%{?enable_vulkan}
BuildRequires:  pkgconfig(vulkan)
%endif
BuildRequires:  pkgconfig(bluez)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(libavcodec)
BuildRequires:	pkgconfig(libva)
BuildRequires:	pkgconfig(libv4l2)
BuildRequires:	pkgconfig(sbc)
BuildRequires:	pkgconfig(sdl2)
BuildRequires:	doxygen
BuildRequires:	xmltoman
BuildRequires:	graphviz
BuildRequires:  libsndfile-devel

Requires(pre):	shadow-utils
Requires:       %{libname}%{?_isa} = %{version}-%{release}
Requires:	systemd >= 184
Requires:	rtkit

%description
PipeWire is a multimedia server for Linux and other Unix like operating
systems.

#------------------------------------------------

%package -n	%{libname}
Summary:        Libraries for PipeWire clients
Group:		System/Libraries
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}
Obsoletes:      %{name}-libpulse < %{version}-%{release}

%description -n	%{libname}
This package contains the runtime libraries for any application that wishes
to interface with a PipeWire media server.

#------------------------------------------------

%package -n	gstreamer1.0-%{name}
Summary:        GStreamer elements for PipeWire
Group:		System/Servers
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}

%description -n	gstreamer1.0-%{name}
This package contains GStreamer elements to interface with a
PipeWire media server.

#------------------------------------------------

%package -n	%{devname}
Summary:        Headers and libraries for PipeWire client development
Group:		Development/C++
License:        MIT
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	spa-devel = %{version}-%{release}

%description -n	%{devname}
Headers and libraries for developing applications that can communicate with
a PipeWire media server.

#------------------------------------------------

%package	doc
Summary:	PipeWire media server documentation
License:        MIT
Group:		Documentation
BuildArch:	noarch
Requires:	%{name} >= %{version}-%{release}

%description	doc
This package contains documentation for the PipeWire media server.

#------------------------------------------------

%package	utils
Summary:	PipeWire media server utilities
License:        MIT
Group:		System/Servers
Requires:       %{name} = %{version}-%{release}

%description	utils
This package contains command line utilities for the PipeWire media server.

%if 0%{?enable_alsa}
%package alsa
Summary:        PipeWire media server ALSA support
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}

%description alsa
This package contains an ALSA plugin for the PipeWire media server.
%endif

%if 0%{?enable_jack}
%package libjack
Summary:        PipeWire libjack library
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}
Requires:       %{libname}%{?_isa} = %{version}-%{release}
BuildRequires:  pkgconfig(jack) >= 1.9.10
Conflicts:      %{mklibname jack 0}
Conflicts:      jack-audio-connection-kit-dbus
# Renamed in F32
Obsoletes:      pipewire-jack < 0.2.96-2
# Fixed jack subpackages
Conflicts:      %{name}-libjack < 0.3.13-6
Conflicts:      %{name}-jack-audio-connection-kit < 0.3.13-6
Obsoletes:      %{name}-jack-audio-connection-kit < 0.3.13-6

%description libjack
This package contains a PipeWire replacement for JACK audio connection kit
"libjack" library.

%package jack-audio-connection-kit
Summary:        PipeWire JACK implementation
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-libjack%{?_isa} = %{version}-%{release}
BuildRequires:  pkgconfig(jack) >= 1.9.10
Conflicts:      %{mklibname jack 0}
Conflicts:      jack-audio-connection-kit-dbus
# Fixed jack subpackages
Conflicts:      %{name}-libjack < 0.3.13-6
Conflicts:      %{name}-jack-audio-connection-kit < 0.3.13-6

%description jack-audio-connection-kit
This package provides a JACK implementation based on PipeWire

%package plugin-jack
Summary:        PipeWire media server JACK support
License:        MIT
BuildRequires:  pkgconfig(jack) >= 1.9.10
Recommends:     %{name}%{?_isa} = %{version}-%{release}
Requires:       %{libname}%{?_isa} = %{version}-%{release}
Requires:       jackit

%description plugin-jack
This package contains the PipeWire spa plugin to connect to a JACK server.
%endif

%if 0%{?enable_pulse}
%package pulseaudio
Summary:        PipeWire PulseAudio implementation
License:        MIT
Recommends:     %{name}%{?_isa} = %{version}-%{release}
Requires:       %{libname}%{?_isa} = %{version}-%{release}
BuildRequires:  %{mklibname pulseaudio 0}
Conflicts:      pulseaudio
# Fixed pulseaudio subpackages
Conflicts:      %{name}-libpulse < 0.3.13-6
Conflicts:      %{name}-pulseaudio < 0.3.13-6

%description pulseaudio
This package provides a PulseAudio implementation based on PipeWire
%endif

%prep
%setup -q -T -b0

%build
%meson \
    -D docs=true -D man=true -D gstreamer=true -D systemd=true 		\
    -D gstreamer-device-provider=false					\
    %{!?enable_jack:-D jack=false -D pipewire-jack=false} 		\
    %{!?enable_pulse:-D pipewire-pulseaudio=false}			\
    %{!?enable_alsa:-D pipewire-alsa=false}				\
    %{!?enable_vulkan:-D vulkan=false}
%meson_build

%install
%meson_install

%if 0%{?enable_jack}
mkdir -p %{buildroot}%{_sysconfdir}/ld.so.conf.d/
echo %{_libdir}/pipewire-%{apiversion}/jack/ > %{buildroot}%{_sysconfdir}/ld.so.conf.d/pipewire-jack-%{_arch}.conf
%endif

%if 0%{?enable_alsa}
mkdir -p %{buildroot}%{_sysconfdir}/alsa/conf.d/
cp %{buildroot}%{_datadir}/alsa/alsa.conf.d/50-pipewire.conf \
        %{buildroot}%{_sysconfdir}/alsa/conf.d/50-pipewire.conf
cp %{buildroot}%{_datadir}/alsa/alsa.conf.d/99-pipewire-default.conf \
        %{buildroot}%{_sysconfdir}/alsa/conf.d/99-pipewire-default.conf
touch %{buildroot}%{_sysconfdir}/pipewire/media-session.d/with-alsa
%endif

# upstream should use udev.pc
mkdir -p %{buildroot}%{_prefix}/lib/udev/rules.d
mv -fv %{buildroot}/lib/udev/rules.d/90-pipewire-alsa.rules %{buildroot}%{_prefix}/lib/udev/rules.d


%check
%meson_test || TESTS_ERROR=$?
if [ "${TESTS_ERROR}" != "" ]; then
echo "test failed"
%{!?tests_nonfatal:exit $TESTS_ERROR}
fi

%pre
getent group pipewire >/dev/null || groupadd -r pipewire
getent passwd pipewire >/dev/null || \
    useradd -r -g pipewire -d /run/pipewire -s /sbin/nologin -c "PipeWire System Daemon" pipewire
exit 0

%post
%systemd_user_post pipewire.service
%systemd_user_post pipewire.socket

%if 0%{?enable_pulse}
%post pulseaudio
%systemd_user_post pipewire-pulse.service
%systemd_user_post pipewire-pulse.socket

%endif

%files
%license LICENSE COPYING
%doc README.md
%{_userunitdir}/pipewire.*
%{_bindir}/pipewire
%{_bindir}/pipewire-media-session
%{_bindir}/pw-top
%{_libdir}/pipewire-%{apiversion}/libpipewire-*.so
%dir %{_datadir}/alsa-card-profile/
%dir %{_datadir}/alsa-card-profile/mixer/
%{_datadir}/alsa-card-profile/mixer/paths/
%{_datadir}/alsa-card-profile/mixer/profile-sets/
%{_prefix}/lib/udev/rules.d/90-pipewire-alsa.rules
%{_libdir}/spa-%{spaversion}
%{_mandir}/man1/pipewire.1*
%dir %{_sysconfdir}/pipewire/
%dir %{_sysconfdir}/pipewire/media-session.d/
%config(noreplace) %{_sysconfdir}/pipewire/media-session.d/media-session.conf
%config(noreplace) %{_sysconfdir}/pipewire/pipewire.conf
%{_mandir}/man5/pipewire.conf.5*

%files -n %{libname}
%license LICENSE COPYING
%doc README.md
%{_libdir}/lib%{name}-%{apiversion}.so.%{soversion}{,.*}

%files -n gstreamer1.0-%{name}
%{_libdir}/gstreamer-1.0/libgstpipewire.*

%files -n %{devname}
%{_libdir}/libpipewire-%{apiversion}.so
%{_includedir}/pipewire-%{apiversion}/
%{_includedir}/spa-%{spaversion}/
%{_libdir}/pkgconfig/libpipewire-%{apiversion}.pc
%{_libdir}/pkgconfig/libspa-%{spaversion}.pc

%files doc
%{_datadir}/doc/pipewire/html

%files utils
%{_bindir}/pw-mon
%{_bindir}/pw-metadata
%{_bindir}/pw-mididump
%{_bindir}/pw-midiplay
%{_bindir}/pw-midirecord
%{_bindir}/pw-cli
%{_bindir}/pw-dot
%{_bindir}/pw-cat
%{_bindir}/pw-dump
%{_bindir}/pw-play
%{_bindir}/pw-profiler
%{_bindir}/pw-record
%{_bindir}/pw-reserve
%{_mandir}/man1/pw-mon.1*
%{_mandir}/man1/pw-cli.1*
%{_mandir}/man1/pw-cat.1*
%{_mandir}/man1/pw-dot.1*
%{_mandir}/man1/pw-metadata.1*
%{_mandir}/man1/pw-mididump.1*
%{_mandir}/man1/pw-profiler.1*

%{_bindir}/spa-acp-tool
%{_bindir}/spa-inspect
%{_bindir}/spa-monitor
%{_bindir}/spa-resample

%if 0%{?enable_alsa}
%files alsa
%{_libdir}/alsa-lib/libasound_module_pcm_pipewire.so
%{_libdir}/alsa-lib/libasound_module_ctl_pipewire.so
%{_datadir}/alsa/alsa.conf.d/50-pipewire.conf
%{_datadir}/alsa/alsa.conf.d/99-pipewire-default.conf
%config(noreplace) %{_sysconfdir}/alsa/conf.d/50-pipewire.conf
%config(noreplace) %{_sysconfdir}/alsa/conf.d/99-pipewire-default.conf
%config(noreplace) %{_sysconfdir}/pipewire/media-session.d/alsa-monitor.conf
%config(noreplace) %{_sysconfdir}/pipewire/media-session.d/with-alsa
%endif

%if 0%{?enable_jack}
%files jack-audio-connection-kit
%{_bindir}/pw-jack
%{_mandir}/man1/pw-jack.1*
%{_libdir}/pipewire-%{apiversion}/jack/libjack.so*
%{_libdir}/pipewire-%{apiversion}/jack/libjacknet.so*
%{_libdir}/pipewire-%{apiversion}/jack/libjackserver.so*
%config(noreplace) %{_sysconfdir}/pipewire/media-session.d/with-jack

%files libjack
%{_sysconfdir}/ld.so.conf.d/pipewire-jack-%{_arch}.conf

%files plugin-jack
%{_libdir}/spa-%{spaversion}/jack/
%endif

%if 0%{?enable_pulse}
%files pulseaudio
%{_bindir}/pipewire-pulse
%{_userunitdir}/pipewire-pulse.*
%config(noreplace) %{_sysconfdir}/pipewire/media-session.d/with-pulseaudio
%endif



%changelog
* Sun Jan 10 2021 tmb <tmb> 0.3.19-1.mga8
+ Revision: 1670258
- update to 0.3.19
+ neoclust <neoclust>
- Fix pipewire home path
+ tv <tv>
- 0.3.17

* Fri Nov 20 2020 tv <tv> 0.3.16-3.mga8
+ Revision: 1647898
- Update to 0.3.16
- Add patch to fix crash in kwin (rhbz#1899826)
- add systemd calls in %%post

* Wed Nov 11 2020 tv <tv> 0.3.15-3.mga8
+ Revision: 1644453
- fix deps

* Wed Nov 04 2020 tv <tv> 0.3.15-2.mga8
+ Revision: 1642638
- Add patch to fix screen sharing for old clients

* Wed Nov 04 2020 tv <tv> 0.3.15-1.mga8
+ Revision: 1642589
- Update to 0.3.15

* Mon Nov 02 2020 tv <tv> 0.3.14-2.mga8
+ Revision: 1641601
- Add some pulse server patches

* Fri Oct 30 2020 tv <tv> 0.3.14-1.mga8
+ Revision: 1640707
- Update to 0.3.14
- Fix jack and pulseaudio subpackages to generate dependencies properly

* Wed Oct 14 2020 tv <tv> 0.3.13-4.mga8
+ Revision: 1635951
- Disable device provider for now (rhbz#1884260)

* Thu Oct 01 2020 tv <tv> 0.3.13-3.mga8
+ Revision: 1631442
- Add patches for some crasher bugs (rhbz#1884177)

* Tue Sep 29 2020 tv <tv> 0.3.13-2.mga8
+ Revision: 1631142
- explicitely require the library with the same version
- Add patch to improve pulse compatibility

* Mon Sep 28 2020 tv <tv> 0.3.13-1.mga8
+ Revision: 1630963
- Update to 0.3.13

* Fri Sep 18 2020 tv <tv> 0.3.12-1.mga8
+ Revision: 1628632
- Update to 0.3.12

* Sat Sep 12 2020 tv <tv> 0.3.11-2.mga8
+ Revision: 1625004
- Add some patches to improve pulse compatibility

* Thu Sep 10 2020 tv <tv> 0.3.11-1.mga8
+ Revision: 1624194
- 0.3.11

* Tue Aug 18 2020 tv <tv> 0.3.10-1.mga8
+ Revision: 1615062
- 0.3.10

* Sun Aug 09 2020 tv <tv> 0.3.9-1.mga8
+ Revision: 1612174
- 0.3.9

* Sat Aug 01 2020 tv <tv> 0.3.8-1.mga8
+ Revision: 1610195
- Update to 0.3.8
- Add patch for fix chrome audio hicups
- Add patch for infinite loop in device add/remove

* Wed Jul 22 2020 tv <tv> 0.3.7-2.mga8
+ Revision: 1607797
- Add patch to avoid crash when clearing metadata

* Tue Jul 21 2020 tv <tv> 0.3.7-1.mga8
+ Revision: 1607653
- 0.3.7

* Thu Jun 25 2020 tv <tv> 0.3.6-3.mga8
+ Revision: 1599210
- fix jack subpkg deps

* Thu Jun 11 2020 tv <tv> 0.3.6-2.mga8
+ Revision: 1592284
- really enable jack/pulse/vulkan

* Thu Jun 11 2020 tv <tv> 0.3.6-1.mga8
+ Revision: 1592275
- Add new man pages
- Only build vulkan/pulse/jack in Fedora.
- Update to 0.3.6
- Suppress library provides from pipewire-lib{pulse,jack}
- Add 2 more packages that replace libjack and libpulse
- Add patch to unsubscribe unused sequencer ports
- Add config to disable bluez5 handling by default

* Sat Apr 04 2020 tv <tv> 0.3.2-1.mga8
+ Revision: 1564343
- Update to 0.3.2
- Add config to disable alsa and bluez5 handling by default.
- Add patch to unsubscribe unused sequencer ports
- Change config to only disable bluez5 handling by default.

* Tue Mar 17 2020 tv <tv> 0.3.1-1.mga8
+ Revision: 1557273
- 0.3.1

* Sun Mar 01 2020 daviddavid <daviddavid> 0.3.0-2.mga8
+ Revision: 1552633
- fix dependencies

* Sun Mar 01 2020 tv <tv> 0.3.0-1.mga8
+ Revision: 1552561
- new major version

* Sun Feb 16 2020 umeabot <umeabot> 0.2.7-2.mga8
+ Revision: 1536361
- Mageia 8 Mass Rebuild

* Thu Oct 17 2019 daviddavid <daviddavid> 0.2.7-1.mga8
+ Revision: 1454270
- new version: 0.2.7

* Sat Jun 15 2019 ngompa <ngompa> 0.2.6-1.mga7
+ Revision: 1400030
- Update to 0.2.6

* Thu Apr 18 2019 umeabot <umeabot> 0.2.5-3.mga7
+ Revision: 1392862
- Rebuild with meson 0.50.1

* Thu Mar 14 2019 daviddavid <daviddavid> 0.2.5-2.mga7
+ Revision: 1376259
- add upstream patch to avoid invalid conversion error with C++ compilers

* Fri Mar 08 2019 daviddavid <daviddavid> 0.2.5-1.mga7
+ Revision: 1372905
- new version: 0.2.5

* Fri Nov 23 2018 tv <tv> 0.2.4-1.mga7
+ Revision: 1333462
- fix filelist
- new release

* Mon Sep 17 2018 daviddavid <daviddavid> 0.2.3-2.mga7
+ Revision: 1259380
- split out the GStreamer 1.0 plugin in a separate sub-pkg
- enable libva, libavcodec and sdl2 support
- doc sub-pkg should be noarch
- add some missing Group
- use a named-versioned github tarball
- add some missing provides on devel sub-pkg

* Mon Sep 17 2018 tv <tv> 0.2.3-1.mga7
+ Revision: 1259375
- new release
- libify
+ ngompa <ngompa>
- imported package pipewire


* Tue Jul 31 2018 Wim Taymans <wtaymans@redhat.com> - 0.2.2-1
- Update to 0.2.2

* Fri Jul 20 2018 Wim Taymans <wtaymans@redhat.com> - 0.2.1-1
- Update to 0.2.1

* Tue Jul 17 2018 Wim Taymans <wtaymans@redhat.com> - 0.2.0-1
- Update to 0.2.0

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Feb 27 2018 Wim Taymans <wtaymans@redhat.com> - 0.1.9-1
- Update to 0.1.9

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.8-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Feb 03 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.1.8-2
- Switch to %%ldconfig_scriptlets

* Tue Jan 23 2018 Wim Taymans <wtaymans@redhat.com> - 0.1.8-1
- Update to 0.1.8

* Fri Nov 24 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.7-1
- Update to 0.1.7
- Add to build when memfd_create is already defined

* Fri Nov 03 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.6-1
- Update to 0.1.6

* Tue Sep 19 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.5-2
- Add patch to avoid segfault when probing

* Tue Sep 19 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.5-1
- Update to 0.1.5

* Thu Sep 14 2017 Kalev Lember <klember@redhat.com> - 0.1.4-3
- Rebuilt for GNOME 3.26.0 megaupdate

* Fri Sep 08 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.4-2
- Install SPA hooks

* Wed Aug 23 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.4-1
- Update to 0.1.4

* Wed Aug 09 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.3-1
- Update to 0.1.3

* Tue Jul 04 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.2-1
- Update to 0.1.2
- Added more build requirements
- Make separate doc package

* Mon Jun 26 2017 Wim Taymans <wtaymans@redhat.com> - 0.1.1-1
- Update to 0.1.1
- Add dbus-1 to BuildRequires
- change libs-devel to -devel

* Wed Sep 9 2015 Wim Taymans <wtaymans@redhat.com> - 0.1.0-2
- Fix BuildRequires to use pkgconfig, add all dependencies found in configure.ac
- Add user and groups  if needed
- Add license to %%licence

* Tue Sep 1 2015 Wim Taymans <wtaymans@redhat.com> - 0.1.0-1
- First version
